commit:     277dd37ce175f19f9deeba50fb83baac8562032b
Author:     Esteve Varela Colominas <esteve.varela <AT> gmail <DOT> com>
AuthorDate: Thu Nov 20 22:14:02 2025 +0000
Commit:     Yixun Lan <dlan <AT> gentoo <DOT> org>
CommitDate: Sun Nov 23 09:46:49 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=277dd37c

media-libs/tg_owt: Bump to 0_pre20251117

Part-of: https://github.com/gentoo/gentoo/pull/44707
Signed-off-by: Esteve Varela Colominas <esteve.varela <AT> gmail.com>
Signed-off-by: Yixun Lan <dlan <AT> gentoo.org>

 media-libs/tg_owt/Manifest                    |   1 +
 media-libs/tg_owt/tg_owt-0_pre20251117.ebuild | 128 ++++++++++++++++++++++++++
 2 files changed, 129 insertions(+)

diff --git a/media-libs/tg_owt/Manifest b/media-libs/tg_owt/Manifest
index ef566ce6c748..746b791417ca 100644
--- a/media-libs/tg_owt/Manifest
+++ b/media-libs/tg_owt/Manifest
@@ -2,3 +2,4 @@ DIST libsrtp-a566a9cfcd619e8327784aa7cff4a1276dc1e895.tar.gz 
636836 BLAKE2B 496a
 DIST libyuv-04821d1e7d60845525e8db55c7bcd41ef5be9406.tar.bz2 418856 BLAKE2B 
a72e1f75491785b272b0ded46368a67aadb643278e5764d16dcd902ab7e4139d8664ffbacd940f30113ce3171e0b0846fe0d6111ced17c5b08f326cd61b2af14
 SHA512 
ff9cfbb61a1361e959740d00c741dc6fbe71ca7c61770abc35f70aada402df3884d7d5992ae79472dfe3d7641154d4f13065593fee41bf8eae924e26cc654117
 DIST tg_owt-0_pre20241202.tar.gz 11722610 BLAKE2B 
effe7b833db593bdbf5d923b362cbc8839853e068d22ac1efd39ae8287eac0aeb71e74bf4476fa2a1a1b67c4e7370c6bc3b28d97e510c50b9621761b9b7be219
 SHA512 
10b7d0686fabc289694c659bcd138737b33375d0aad936e0cf8dcdebeebf30e7c0e1af7a9196c4275bcbb88b5867bcefa8179564980941895a6b7d9bfae822b2
 DIST tg_owt-0_pre20250515.tar.gz 11719653 BLAKE2B 
804a72d97b535efb6e6319e609763f2b641cb9962e59d4afd5ea5b98b9b49b5c32344341ca6096899e806c3a115f784975a442c758896913a162a2d96a77703a
 SHA512 
3930584575a61b5c8aeea871be85d0700ccc32b852adb10293ab4267066cfcf6857ceea51b267507f5d23e088c331fb7b42ebccbb71ef9b8a2ecdba60c2ca2e3
+DIST tg_owt-0_pre20251117.tar.gz 11722658 BLAKE2B 
024d4a3d9d1951355b9a4b2470958da32ef3bb2822c38f25e6ab7c6600f8a014bb7021f66738f34ec44e450d5a68832a5411194951ba14db6854fd9df64cd716
 SHA512 
ef2c2163213e2027aebfb5b1f23439a90b428d770fdef986257ab7314bdccc972cd3c2e7048a15092150f9a8479f8480932aed73e1b5ba7817acc1a4034a51b1

diff --git a/media-libs/tg_owt/tg_owt-0_pre20251117.ebuild 
b/media-libs/tg_owt/tg_owt-0_pre20251117.ebuild
new file mode 100644
index 000000000000..dea345887348
--- /dev/null
+++ b/media-libs/tg_owt/tg_owt-0_pre20251117.ebuild
@@ -0,0 +1,128 @@
+# Copyright 2020-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit cmake flag-o-matic
+
+DESCRIPTION="WebRTC build for Telegram"
+HOMEPAGE="https://github.com/desktop-app/tg_owt";
+
+TG_OWT_COMMIT="d067233a845e387e63d480d0d846da5fcb6a40cb"
+LIBYUV_COMMIT="04821d1e7d60845525e8db55c7bcd41ef5be9406"
+LIBSRTP_COMMIT="a566a9cfcd619e8327784aa7cff4a1276dc1e895"
+SRC_URI="https://github.com/desktop-app/tg_owt/archive/${TG_OWT_COMMIT}.tar.gz 
-> ${P}.tar.gz
+       
https://gitlab.com/chromiumsrc/libyuv/-/archive/${LIBYUV_COMMIT}/libyuv-${LIBYUV_COMMIT}.tar.bz2";
+S="${WORKDIR}/${PN}-${TG_OWT_COMMIT}"
+# Upstream libyuv: https://chromium.googlesource.com/libyuv/libyuv
+
+LICENSE="BSD"
+SLOT="0/${PV##*pre}"
+KEYWORDS="~amd64 ~arm64 ~loong ~ppc64 ~riscv"
+IUSE="screencast +X"
+
+# This package's USE flags may change the ABI and require a rebuild of
+#  dependent pacakges. As such, one should make sure to depend on
+#  media-libs/tg_owt[x=,y=,z=] for any package that uses this.
+# Furthermore, the -DNDEBUG preprocessor flag should be defined by any
+#  dependent package, failure to do so will change the ABI in the header files.
+
+# Bundled libs:
+# - libyuv (no stable versioning, www-client/chromium and media-libs/libvpx 
bundle it)
+# - pffft (no stable versioning, patched)
+RDEPEND="
+       >=dev-cpp/abseil-cpp-20240722.0:=
+       dev-libs/openssl:=
+       dev-libs/protobuf:=
+       media-libs/libjpeg-turbo:=
+       >=media-libs/libvpx-1.10.0:=
+       media-libs/openh264:=
+       media-libs/opus
+       media-video/ffmpeg:=
+       net-libs/libsrtp:2=
+       dev-libs/crc32c
+       screencast? (
+               dev-libs/glib:2
+               >=media-video/pipewire-1.0.7:=
+       )
+       X? (
+               x11-libs/libX11
+               x11-libs/libXcomposite
+               x11-libs/libXdamage
+               x11-libs/libXext
+               x11-libs/libXfixes
+               x11-libs/libXrender
+               x11-libs/libXrandr
+               x11-libs/libXtst
+       )
+"
+DEPEND="${RDEPEND}
+       screencast? (
+               media-libs/libglvnd[X]
+               media-libs/mesa
+               x11-libs/libdrm
+       )
+"
+BDEPEND="
+       virtual/pkgconfig
+       X? ( x11-base/xorg-proto )
+"
+
+PATCHES=(
+       "${FILESDIR}/tg_owt-0_pre20250515-fix-gcc16.patch"
+       "${FILESDIR}/tg_owt-0_pre20250515-fix-clang20.patch"
+)
+
+src_unpack() {
+       default
+       mv -T "libyuv-${LIBYUV_COMMIT}" "${S}/src/third_party/libyuv" || die
+}
+
+src_prepare() {
+       # The sources for these aren't available, avoid needing them
+       sed -e '/include(cmake\/libcrc32c.cmake)/d' \
+               -e '/include(cmake\/libabsl.cmake)/d' -i CMakeLists.txt || die
+
+       # "lol" said the scorpion, "lmao"
+       sed -i '/if (BUILD_SHARED_LIBS)/{n;n;s/WARNING/DEBUG/}' CMakeLists.txt 
|| die
+
+       # Shut the CMake 4 QA checker up by removing unused CMakeLists files
+       rm src/third_party/libyuv/CMakeLists.txt || die
+
+       cmake_src_prepare
+}
+
+src_configure() {
+       # Defined by -DCMAKE_BUILD_TYPE=Release, avoids crashes
+       # See https://bugs.gentoo.org/754012
+       # EAPI 8 still wipes this flag.
+       append-cppflags '-DNDEBUG'
+
+       local mycmakeargs=(
+               -DTG_OWT_USE_X11=$(usex X)
+               -DTG_OWT_USE_PIPEWIRE=$(usex screencast)
+       )
+       cmake_src_configure
+}
+
+src_install() {
+       cmake_src_install
+
+       # Save about 15MB of useless headers
+       rm -r "${ED}/usr/include/tg_owt/rtc_base/third_party" || die
+       rm -r "${ED}/usr/include/tg_owt/common_audio/third_party" || die
+       rm -r "${ED}/usr/include/tg_owt/modules/third_party" || die
+       rm -r "${ED}/usr/include/tg_owt/third_party" || die
+
+       # Install a few headers anyway, as required by 
net-im/telegram-desktop...
+       local headers=(
+               third_party/libyuv/include
+               rtc_base/third_party/sigslot
+               rtc_base/third_party/base64
+       )
+       for dir in "${headers[@]}"; do
+               pushd "${S}/src/${dir}" > /dev/null || die
+               find -type f -name "*.h" -exec install -Dm644 '{}' 
"${ED}/usr/include/tg_owt/${dir}/{}" \; || die
+               popd > /dev/null || die
+       done
+}

Reply via email to